#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QtWidgets/QPlainTextEdit>
#include "data.h"

namespace Ui {
class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

  public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();

  private slots:
    void on_rb_bl_set_clicked();

    void on_rb_bl_none_clicked();

    void on_rb_bl_keep_clicked();

    void on_rb_fmt_prfx_clicked();

    void on_rb_fmt_space_clicked();

    void on_rb_fmt_seq_clicked();

    void on_btn_fmt_left_clicked();

    void on_btn_fmt_right_clicked();

    void on_btn_trans_left_clicked();

    void on_btn_trans_right_clicked();

    void on_btn_rand_left_clicked();

    void on_btn_rand_right_clicked();

    void on_ln_bl_byte_editingFinished();

  private:
    Ui::MainWindow *ui;
    int bpl;
    Data::format fmt;
    void unify_rand(QPlainTextEdit *to);
    void unify_trns(QPlainTextEdit *from, QPlainTextEdit *to);
    void unify_fmt(QPlainTextEdit *from, QPlainTextEdit *to);
};

#endif // MAINWINDOW_H
